'-------------------------------------------------------------------------------
'                              SSD1306
'                      BASCOM-AVR - Mrshilov 2015
'===============================================================================
$regfile = "m644def.dat"
$crystal = 8000000
$hwstack = 64
$swstack = 64
$framesize = 64
Config Clockdiv = 1
Mcucr.7 = 1                                                 'Turn OFF JTAG
Mcucr.7 = 1


'-------------------------------- I2C bus --------------------------------------
$lib "i2c_twi.lbx"                                          ' hardware I2C
Config Scl = Portc.0                                        ' used i2c pins
Config Sda = Portc.1
Config Twi = 400000                                         ' i2c speed
I2cinit
Waitms 5


'-------------------------------- Display --------------------------------------
$lib "glcdSSD1306-I2C-Buf.lib"
Config Graphlcd = Custom , Cols = 128 , Rows = 64 , Lcdname = "SSD1306"
Dim Lcd_auto As Byte
Lcd_auto = 1
Const Rotate_180 = 0

#if _build < 20784
Dim ___lcdrow As Byte , ___lcdcol As Byte                   ' dim these for older compiler versions
#endif


Dim I As Byte , N As Byte

'============================== Program ========================================

Do

   '---------------- AUTO mode ------------------
   Lcd_auto = 1

   Cls
   Setfont Font12x16
   Lcdat 0 , 22 , "SSD1306"
   Setfont Font8x8tt
   Lcdat 2 , 22 , " AUTO mode "
   Wait 1

   'Lcd_auto = 0
   Lcdat 4 , 42 , " PIXEL "
   For I = 5 To 30 Step 5
      For N = 32 To 58 Step 5
         Pset I , N , 1
      Next N
   Next I
   For I = 97 To 122 Step 5
      For N = 32 To 58 Step 5
         Pset I , N , 1
      Next N
   Next I
   'Gosub _update_screen
   'Lcd_auto = 1
   Wait 1
   Boxfill(5 , 32) -(30 , 58 ) , 0
   Boxfill(97 , 32) -(122 , 58 ) , 0


   Lcdat 4 , 42 , "  BOX  "
   Box(5 , 32) -(30 , 58 ) , 1
   Box(97 , 32) -(122 , 58 ) , 1
   Wait 1


   Lcdat 4 , 42 , "BOXFILL"
   Boxfill(5 , 32) -(30 , 58 ) , 1
   Boxfill(97 , 32) -(122 , 58 ) , 1
   Wait 1

   Boxfill(5 , 32) -(30 , 58 ) , 0
   Boxfill(97 , 32) -(122 , 58 ) , 0


   Lcdat 4 , 42 , " LINE  "
   Line(5 , 32) -(30 , 58 ) , 1
   Line(5 , 58) -(30 , 32 ) , 1
   Line(97 , 32) -(122 , 58 ) , 1
   Line(97 , 58) -(122 , 32 ) , 1
   Wait 1
   Boxfill(5 , 32) -(30 , 58 ) , 0
   Boxfill(97 , 32) -(122 , 58 ) , 0


   Lcdat 4 , 40 , " CIRCLE "
   Circle(17 , 45 ) , 13 , 1
   Circle(110 , 45 ) , 13 , 1
   Wait 1
   Boxfill(4 , 32) -(125 , 60 ) , 0


   Lcdat 4 , 20 , "CONTRAST"
   For N = 255 To 0 Step - 1
      Lcdcontrast N
      Lcdat 4 , 87 , N ; "  "
      Waitms 5
   Next N
   Wait 1
   For N = 1 To 255
      Lcdcontrast N
      Lcdat 4 , 87 , N ; "  "
      Waitms 5
   Next N

   Showpic 0 , 0 , Picture
   Wait 1



   '------------ HAND mode ---------------
   Lcd_auto = 0

   Cls
   Setfont Font12x16
   Lcdat 0 , 22 , "SSD1306"
   Setfont Font8x8tt
   Lcdat 2 , 22 , " HAND mode"
   Gosub _update_screen
   Wait 1


   Lcdat 4 , 42 , " PIXEL "
   For I = 5 To 30 Step 5
      For N = 32 To 58 Step 5
         Pset I , N , 1
      Next N
   Next I
   For I = 97 To 122 Step 5
      For N = 32 To 58 Step 5
         Pset I , N , 1
      Next N
   Next I
   Gosub _update_screen
   Wait 1
   Boxfill(5 , 32) -(30 , 58 ) , 0
   Boxfill(97 , 32) -(122 , 58 ) , 0
   Gosub _update_screen


   Lcdat 4 , 42 , "  BOX  "
   Box(5 , 32) -(30 , 58 ) , 1
   Box(97 , 32) -(122 , 58 ) , 1
   Gosub _update_screen
   Wait 1


   Lcdat 4 , 42 , "BOXFILL"
   Boxfill(5 , 32) -(30 , 58 ) , 1
   Boxfill(97 , 32) -(122 , 58 ) , 1
   Gosub _update_screen
   Wait 1
   Boxfill(5 , 32) -(30 , 58 ) , 0
   Boxfill(97 , 32) -(122 , 58 ) , 0


   Lcdat 4 , 42 , " LINE  "
   Line(5 , 32) -(30 , 58 ) , 1
   Line(5 , 58) -(30 , 32 ) , 1
   Line(97 , 32) -(122 , 58 ) , 1
   Line(97 , 58) -(122 , 32 ) , 1
   Gosub _update_screen
   Wait 1
   Boxfill(5 , 32) -(30 , 58 ) , 0
   Boxfill(97 , 32) -(122 , 58 ) , 0


   Lcdat 4 , 40 , " CIRCLE "
   Circle(17 , 45 ) , 13 , 1
   Circle(110 , 45 ) , 13 , 1
   Gosub _update_screen
   Wait 1
   Boxfill(4 , 32) -(125 , 60 ) , 0


   Lcdat 4 , 20 , "CONTRAST"
   For N = 255 To 0 Step - 1
      Lcdcontrast N
      Lcdat 4 , 87 , N ; "  "
      Gosub _update_screen
      Waitms 5
   Next N
   Wait 1
   For N = 1 To 255
      Lcdcontrast N
      Lcdat 4 , 87 , N ; "  "
      Gosub _update_screen
      Waitms 5
   Next N

   Showpic 0 , 0 , Picture
   Gosub _update_screen
   Wait 1


Loop
End                                                         'end program
'-------------------------------------------------------------------------------
$include "font8x8TT.font"
$include "font12x16.font"
Picture:
$bgf "picture.bgf"